//+------------------------------------------------------------------+
//|                                          DataExtractorAsIndi.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property indicator_chart_window



string filename = "DataExtractorAsIndi.csv";
int currBar;
int lookBack = 2;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   int handle=FileOpen(filename,FILE_WRITE|FILE_CSV);
   
   if(handle<0)
   {
      MessageBox("FileOpen() function returned the "+GetLastError()+" error\nContinue?", "Question");
      return(500);
      
   }
   string cache = ";";
   for(int i=0; i<lookBack;i++)
   {
      cache = cache + i+";";
   }
   
   FileWrite(handle,cache);
   FileClose(handle);
   currBar = Bars-1;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
  {
  if(currBar!=Bars)
  {
   currBar=Bars;
   
   int handle=FileOpen(filename,FILE_READ|FILE_WRITE|FILE_CSV);
   
   if(handle>0)
    {
     FileSeek(handle, 0, SEEK_END);

      FileWrite(handle,TimeToStr(Time[0]));
      
      string indis ="PERIOD_M1;";
      for(int i=0; i<lookBack; i++)
      {
         string cache = DoubleToStr(iSAR(Symbol(), PERIOD_M1, 0.02,0.2,i),8)+";";
         StringSetChar(cache, 1, ',');
         indis = indis + cache;
      }
      FileWrite(handle,indis);
      
      indis ="PERIOD_M5;";
      for(i=0; i<lookBack; i++)
      {
         cache = DoubleToStr(iSAR(Symbol(), PERIOD_M5, 0.02,0.2,i),8)+";";
         StringSetChar(cache, 1, ',');
         indis = indis + cache;
      }
      FileWrite(handle,indis);
      
      indis ="PERIOD_M15;";
      for(i=0; i<lookBack; i++)
      {
         cache = DoubleToStr(iSAR(Symbol(), PERIOD_M15, 0.02,0.2,i),8)+";";
         StringSetChar(cache, 1, ',');
         indis = indis + cache;
      }
      FileWrite(handle,indis);
      
      indis ="PERIOD_M30;";
      for(i=0; i<lookBack; i++)
      {
         cache = DoubleToStr(iSAR(Symbol(), PERIOD_M30, 0.02,0.2,i),8)+";";
         StringSetChar(cache, 1, ',');
         indis = indis + cache;
      }
      FileWrite(handle,indis);
      
      indis ="PERIOD_H1;";
      for(i=0; i<lookBack; i++)
      {
         cache = DoubleToStr(iSAR(Symbol(), PERIOD_H1, 0.02,0.2,i),8)+";";
         StringSetChar(cache, 1, ',');
         indis = indis + cache;
      }
      FileWrite(handle,indis);
      
      FileClose(handle);
      
      
    }
  }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+